import java.io.*;
import java.rmi.*;
import java.rmi.registry.*;
import java.rmi.server.*;
import java.util.*;

public class SrvImpl implements Runnable, Srv  {

    Vector<Cli> v = new Vector<Cli>();

    public void addClient(Cli c){
        synchronized(v){
            v.add(c);
        }
    }
    
    public void removeClient(Cli c){
        synchronized(v){
            v.removeElement(c);
        }
    }

    public void run(){
        for(;;){
            synchronized(v){
                try {
                for(Cli c : v){
                    try {
                        c.msg((new java.util.Date()).toString());
                    }catch(Exception e){ }
                }
                Thread.sleep(100);
                }catch(Exception e){};
            }
        }
    }

    public static void main(String[] args) throws Throwable {
        
        Srv t = new SrvImpl();

        // create a wrapper we can store in registry.
        Srv stub = (Srv)UnicastRemoteObject.exportObject(t,0);
        
        Thread th = new Thread((Runnable)t);
        th.start();

        // find registry instance.
        Registry r = LocateRegistry.getRegistry();
        r.rebind("Srv",stub);
    }
}

